#include "trigsimp.h"
#include <giac/giac.h>
#include <string>
#include <sstream>
#include <ctime>

using namespace std;
using namespace giac;

const string test_exprv[] = {
    "1/sin(pi/18)-sqrt(3)/cos(pi/18)",
    "cos(2x)/(sin(x)+cos(x))^2+2*(sin(x)^3-cos(x)^3)/(sin(x)+cos(x))",
    "sin(3*pi/4-2x)^2-sin(7*pi/6-2x)^2-sin(13*pi/12)*cos(11*pi/12-4x)",
    "sin(x)^6+cos(x)^6-4/4*(sin(x)^2-cos(x)^2)^2",
    "sin(3x)/sin(x)-cos(3x)/cos(x)",
    "cos(pi/9)*cos(2*pi/9)*cos(3*pi/9)*cos(4*pi/9)",
    "3*sin(x)-4*sin(x)^3",
    "(10*cos(x)+5*cos(3x)+cos(5x))/16",
    "(3-4*cos(2x)+cos(4x))/(3+4*cos(2x)+cos(4x))",
    "2*pi*sin(a*pi)/(1-cos(2*a*pi))",
    "sin(2x)^3*cos(6x)+cos(2x)^3*sin(6x)",
    "(sin(x-a)/sin(x-b)*cos(x-a)/cos(x-b)+1)/(cos(x-a)/cos(x-b)+sin(x-a)/sin(x-b))",
    "1/tan(7*pi/18)+4*cos(7*pi/18)",
    "sin(6x)-2*sqrt(3)*cos(3x)^2+sqrt(3)",
    "sum(sin(k*x),k=1..5)/sum(cos(k*x),k=1..5)",
    "(1+sin(x))/(1-sin(x))+(sin(x)-1)/(sin(x)+1)",
    "(sin(x+y)-sin(x-y))/(cos(x+y)+cos(x-y))",
    "(sin(x)^3-cos(x)^3)/(sin(x)-cos(x))",
    "tan(x)+cos(x)/(1+sin(x))",
    "1/(1+cos(x))+1/(1-cos(x))",
    "(sin(3x)+sin(7x))/(cos(3x)-cos(7x))",
    "(tan(a+b)-tan(b))/(1+tan(a+b)*tan(b))",
    "cos(x)^2/(1-sin(x))",
    "1-1/4*sin(2a)^2-sin(b)^2-cos(a)^4",
    "sin(10x)/(sin(x)+sin(9x))"
};

int main(){
    context ct;
    gen g;
    for (int i=0;i<25;++i) {
        stringstream ss;
        ss << test_exprv[i];
        ss >> g;
        gen ord_simp(_simplify(g,&ct));
        clock_t begin = clock();
        gen simp(_trigsimplify(g,&ct));
        clock_t end = clock();
        double elapsed=double(end-begin)/CLOCKS_PER_SEC;
        cout << i+1 << ") simplifying " << g << ",  time: " << elapsed << " sec" << endl
             << "Result: " << simp << endl
             << "Ordinary simplification: " << ord_simp << endl;
    }
    return 0;
}
